<?php

/**
 * Plugin Name: Alkane Code
 * Plugin URI: https://www.alkanesolutions.co.uk/blog/2019/07/06/alkane-code-tinymce-code-editor-prism-syntax-highlighting/
 * Version: 1.0.9
 * Author: Alkane Solutions Ltd
 * Author URI: https://www.alkanesolutions.co.uk/
 * Description: A TinyMCE code editor with Prism syntax highlighting.
 * License: GPL2
 */


// No direct access
if (!defined('ABSPATH')) exit;

class alkanecode
{
    
	//all themes supported by Prism.js
    private $global_themes = array(		
		array("Coy","coy"),
		array("Dark","dark"),
		array("Funky","funky"),
		array("Okaidia","okaidia"),
		array("Prism","prism"),
		array("Solarized Light","solarizedlight"),
		array("Tomorrow Night","tomorrow"),
		array("Twilight","twilight")
	);
	
	//all languages supported by Prism.js
	private $global_languages = array
	(
		array( 'ABAP','abap'),
		array( 'Augmented Backus–Naur form','abnf'),
		array( 'ActionScript','actionscript'),
		array( 'Ada','ada'),
		array( 'Apache Configuration','apacheconf'),
		array( 'APL','apl'),
		array( 'Applescript','applescript'),
		array( 'Arduino','arduino'),
		array( 'ARFF','arff'),
		array( 'AsciiDoc','asciidoc'),
		array( 'Assembly 6502','asm6502'),
		array( 'ASP.NET (C#)','aspnet'),
		array( 'AutoHotkey','autohotkey'),
		array( 'AutoIt','autoit'),		
		array( 'Bash','bash'),
		array( 'BASIC','basic'),
		array( 'Batch','batch'),
		array( 'Bison','bison'),
		array( 'Backus–Naur form','bnf'),
		array( 'Brainfuck','brainfuck'),
		array( 'Bro','bro'),
		array( 'C','c'),		
		array( 'C-Like','clike'),		
		array( 'C#','csharp'),		
		array( 'C++','cpp'),
		array( 'CIL','cil'),
		array( 'CoffeeScript','coffeescript'),
		array( 'CMake','cmake'),
		array( 'Clojure','clojure'),
		array( 'Crystal','crystal'),
		array( 'Content-Security-Policy','csp'),
		array( 'CSS','css'),
		array( 'CSS Extras','css-extras'),
		array( 'D','d'),
		array( 'Dart','dart'),
		array( 'Diff','diff'),
		array( 'Django/Jinja2','django'),
		array( 'Docker','docker'),
		array( 'Extended Backus–Naur form','ebnf'),
		array( 'Eiffel','eiffel'),
		array( 'EJS','ejs'),
		array( 'Elixir','elixir'),
		array( 'Elm','elm'),
		array( 'ERB','erb'),
		array( 'Erlang','erlang'),
		array( 'F#','fsharp'),
		array( 'Flow','flow'),
		array( 'Fortran','fortran'),
		array( 'G-code','gcode'),
		array( 'GEDCOM','gedcom'),
		array( 'Gherkin','gherkin'),
		array( 'Git','git'),
		array( 'GLSL','glsl'),
		array( 'GameMaker Language','gml'),
		array( 'Go','go'),
		array( 'GraphQL','graphql'),
		array( 'Groovy','groovy'),
		array( 'Haml','haml'),
		array( 'Handlebars','handlebars'),
		array( 'Haskell','haskell'),
		array( 'Haxe','haxe'),
		array( 'HCL','hcl'),
		array( 'HTML','html'),
		array( 'HTTP','http'),
		array( 'HTTP Public-Key-Pins','hpkp'),
		array( 'HTTP Strict-Transport-Security','hsts'),
		array( 'IchigoJam','ichigojam'),
		array( 'Icon','icon'),
		array( 'Inform 7','inform7'),
		array( 'Ini','ini'),
		array( 'Io','io'),
		array( 'J','j'),
		array( 'Java','java'),
		array( 'JavaDoc','javadoc'),
		array( 'JavaDoc-like','javadoclike'),
		array( 'Java stack trace','javastacktrace'),
		array( 'JavaScript','javascript'),
		array( 'Jolie','jolie'),
		array( 'JQ','jq'),
		array( 'JSDoc','jsdoc'),
		array( 'JS Extras','js-extras'),
		array( 'JSON','json'),
		array( 'JSONP','jsonp'),
		array( 'JSON5','json5'),
		array( 'Julia','julia'),
		array( 'Keyman','keyman'),
		array( 'Kotlin','kotlin'),
		array( 'LaTex','latex'),
		array( 'Less','less'),
		array( 'Liquid','liquid'),
		array( 'Lisp','lisp'),
		array( 'LiveScript','livescript'),
		array( 'LOLCODE','lolcode'),
		array( 'Lua','lua'),
		array( 'Makefile','makefile'),
		array( 'Markdown','markdown'),
		array( 'Markup','markup'),
		array( 'Markup templating','markup-templating'),			
		array( 'MathML','mathml'),
		array( 'MATLAB','matlab'),
		array( 'MEL','mel'),
		array( 'Mizar','mizar'),
		array( 'Monkey','monkey'),
		array( 'N1QL','n1ql'),
		array( 'N4JS','n4js'),
		array( 'Nand To Tetris HDL','nand2tetris-hdl'),		
		array( 'NASM','nasm'),
		array( 'nginx','nginx'),
		array( 'Nim','nim'),
		array( 'Nix','nix'),
		array( 'NSIS','nsis'),
		array( 'Objective-C','objectivec'),
		array( 'OCaml','ocaml'),
		array( 'OpenCL','opencl'),
		array( 'Oz','oz'),
		array( 'PARI/GP','parigp'),					
		array( 'Parser','parser'),
		array( 'Pascal','pascal'),
		array( 'PC-Axis','pcaxis'),
		array( 'Perl','perl'),
		array( 'PHP','php'),
		array( 'PHPDoc','phpdoc'),
		array( 'PHP Extras','php-extras'),
		array( 'PL/SQL','plsql'),
		array( 'PowerShell','powershell'),
		array( 'Processing','processing'),
		array( 'Prolog','prolog'),
		array( '.properties','properties'),
		array( 'Protocol Buffers','protobuf'),
		array( 'Pug','pug'),
		array( 'Puppet','puppet'),
		array( 'Pure','pure'),
		array( 'Python','python'),
		array( 'Q','q'),
		array( 'Qore','qore'),
		array( 'R','r'),
		array( 'React JSX','jsx'),
		array( 'React TSX','tsx'),
		array( 'Ren\'py','renpy'),
		array( 'Reason','reason'),
		array( 'Regex','regex'),
		array( 'reST (reStructuredText)','rest'),
		array( 'Rip','rip'),
		array( 'Roboconf','roboconf'),
		array( 'Ruby','ruby'),
		array( 'Rust','rust'),
		array( 'SAS','sas'),
		array( 'Sass (Sass)','sass'),
		array( 'Sass (Scss)','scss'),
		array( 'Scala','scala'),
		array( 'Scheme','scheme'),
		array( 'Shell session','shell-session'),
		array( 'Smalltalk','smalltalk'),
		array( 'Smarty','smarty'),
		array( 'SQL','sql'),
		array( 'Soy (Closure Template)','soy'),
		array( 'Stylus','stylus'),
		array( 'SVG','svg'),
		array( 'Swift','swift'),	
		array( 'TAP','tap'),		
		array( 'Tcl','tcl'),
		array( 'Textile','textile'),
		array( 'TOML','toml'),
		array( 'Template Toolkit 2','tt2'),
		array( 'Twig','twig'),
		array( 'TypeScript','typescript'),
		array( 'T4 Text Templates (C#)','t4-cs'),
		array( 'T4 Text Templates (VB)','t4-vb'),
		array( 'T4 templating','t4-templating'),
		array( 'Vala','vala'),
		array( 'VB.Net','vbnet'),
		array( 'Velocity','velocity'),		
		array( 'Verilog','verilog'),
		array( 'VHDL','vhdl'),
		array( 'vim','vim'),
		array( 'Visual Basic','visual-basic'),
		array( 'WebAssembly','wasm'),
		array( 'Wiki markup','wiki'),
		array( 'Xeora','xeora'),
		array( 'XML','xml'),
		array( 'Xojo (REALbasic)','xojo'),
		array( 'XQuery','xquery'),		
		array( 'YAML','yaml')
	);
	
	
    /**
     * Constructor. Called when the plugin is initialised.
     */
    function __construct()
    {        
        //if (is_admin()) {
            add_action('init', array(
                $this,
                'alkanecode_setup'
            ));
        //}      
    }
   	
    function alkanecode_setup()
    {
        
        // Check if the logged in WordPress User can edit Posts or Pages
        // If not, don't register our TinyMCE plugin
        
        //if (!current_user_can('edit_posts') && !current_user_can('edit_pages')) {
        //    return;
        //}
        
        // Check if the logged in WordPress User has the Visual Editor enabled
        // If not, don't register our TinyMCE plugin
        //if (get_user_option('rich_editing') !== 'true') {
        //    return;
        //}
        
		//enqueue js and css required for plugin
		add_action('wp_enqueue_scripts', array( &$this, 'alkanecode_enqueue_scripts' ));		
		  
		//add link to settings on plugin page		
		add_filter('plugin_action_links_'.plugin_basename(__FILE__), array( &$this, 'alkanecode_settings_link'));
		  
		//populate list of languages available in code editor
		add_filter( 'tiny_mce_before_init', array( &$this, 'alkanecode_tiny_mce_before_init' ));
		       
		//add plugin to TinyMCE
        add_filter('mce_external_plugins', array( &$this, 'alkanecode_add_tinymce_plugin' ));
		
		//add plugin to TinyMCE Toolbar
        add_filter('mce_buttons', array( &$this,'alkanecode_add_tinymce_toolbar_button' ));
		
		//add classes to body, so that all code instances get line numbers and syntax highlight using 'markup' language as default
		add_filter( 'body_class',array( &$this, 'alkanecode_body_class' ) );
		
		/*****start admin pages***/
		
		//enqueue js and css required for plugin admin pages
		add_action( 'admin_enqueue_scripts', array( &$this, 'alkanecode_admin_enqueue_scripts' ));
		  
		//initialise and configure plugin admin page
		add_action('admin_init', array( &$this, 'alkanecode_admin_init' ));
		  
		//add a link in Settings menu to configure plugin
		add_action('admin_menu', array( &$this, 'alkanecode_admin_menu' ));
		
		/*****end admin pages***/
     
	}

	//enqueue js and css required for plugin
   	function alkanecode_enqueue_scripts()
	{	
		
		wp_enqueue_script( 'prism-config-js', plugin_dir_url( __FILE__ ) . 'prism/js/prism.config.min.js', array('jquery'), null, true );
	   
		//only register style we have configured - if none use default	
		$options = get_option('alkanecode_options');

		$theme = "";

		if (!empty($options)) {
			$theme = strtolower($options['alkanecode_theme']);
		}

		if ($theme == "")
		{
			//default to prism
			$theme = "prism";
		} else {	
			//a theme has been selected
			if ($theme != "prism")
			{	
				$theme = "prism-" . $theme;	
			}
		}		
		
		wp_enqueue_style( 'prism-style', plugin_dir_url( __FILE__ ) . 'prism/css/themes/'.$theme.'.min.css');
		wp_enqueue_style( 'prism-config-style', plugin_dir_url( __FILE__ ) . 'prism/css/prism.config.min.css');		
		
	}
	
	//add link to settings on plugin page
	function alkanecode_settings_link( $links ) {
		$links[] = '<a href="' .admin_url( 'options-general.php?page=alkanecode_settings_page' ) .	'">' . __('Settings') . '</a>';
		return $links;
	}	
	
	//populate list of languages available in code editor
	function alkanecode_tiny_mce_before_init($settings) {
	
		//define empty array for languages
		$languagearray=array();

		//get selected languages
		$alkanecode_languages = get_option('alkanecode_options')["alkanecode_language"];			
			
		//add a blank entry at the top - used for inline code with no language
		$lang=array(
			'text' => '',
			'value' => '',
		);		
		array_push($languagearray,$lang);	
				
				
		if (empty($alkanecode_languages)) {

			$global_languages = $this->global_languages;

			//no languages have been configured so we'll use all		
			foreach($global_languages as $language) {	
						
				$lang=array(
					'text' => $language[0],
					'value' => $language[1],
				);		
				array_push($languagearray,$lang);					
			}			
			
		} else {
			
			//iterate through selected languages, displaying only those chosen		
			foreach($alkanecode_languages as $value => $text) {	
	
				$lang=array(
					'text' => $text,
					'value' => $value,
				);		
				array_push($languagearray,$lang);					
			}		
		}
			 
		$settings['alkanecode_languages'] = json_encode( $languagearray );		
		
		return $settings;
	}

	//add plugin to TinyMCE
 	function alkanecode_add_tinymce_plugin($plugin_array)
    {
        $plugin_array['alkanecode'] = plugin_dir_url(__FILE__) . 'js/alkanecode.js';
        return $plugin_array;        
    }
	
	//add plugin to TinyMCE Toolbar
	function alkanecode_add_tinymce_toolbar_button($buttons)
    {        
        array_push($buttons, 'alkanecode');
        return $buttons;        
    }
	
	//add classes to body, so that all code instances get line numbers and syntax highlight using 'markup' language as default
	function alkanecode_body_class( $bodyclasses ) {
	
		//add line-numbers and a default language to body class
		$bodyclasses = array_merge( $bodyclasses, array( 'line-numbers' ) );
		//default language
		$bodyclasses = array_merge( $bodyclasses, array( 'language-markup' ) );
		
		return $bodyclasses;		
	}
	
    
	/*****start admin pages***/
		
			
	//enqueue js and css required for plugin admin pages
	function alkanecode_admin_enqueue_scripts ($hook) {
        	
		//only load on the alkane admin page		
      	if($hook != 'settings_page_alkanecode_settings_page') {			
       		return;
        }
		
		wp_enqueue_script( 'alkanecode_admin_js', plugin_dir_url( __FILE__ ) . 'js/alkanecode-admin.js', array('jquery'),null,true );
		wp_enqueue_style( 'alkanecode_admin_css', plugin_dir_url( __FILE__ ) . 'css/alkanecode-admin.css');		
		
	}

	//initialise and configure plugin admin page
	function alkanecode_admin_init(){
		
		register_setting( 'alkanecode_optiongroupname', 'alkanecode_options');
		add_settings_section('alkanecode_main', 'Main Settings', array($this,'alkanecode_sectiondescription'), 'alkanecode_settings_page');	
		add_settings_field('alkanecode_theme_setting', 'Theme', array($this,'alkanecode_setting_theme'), 'alkanecode_settings_page', 'alkanecode_main');
		add_settings_field('alkanecode_language_setting', 'Language(s)', array($this,'alkanecode_setting_language'), 'alkanecode_settings_page', 'alkanecode_main');

	}

	//render intro paragraph for admin page
	function alkanecode_sectiondescription() {
		//echo '<p></p>';	
	}	

	//render theme section in admin page
	function alkanecode_setting_theme() {
			
		//$csc = new alkanecodeClass();	
		$global_themes = $this->global_themes;
			
		$options = get_option('alkanecode_options')["alkanecode_theme"];
			
		echo '<div class="alkanecode-row">Configure the theme that Prism will use when syntax highlighting your code.  If no theme is configured the \'Prism\' theme will be used by default.</div><br />';
			
		echo "<select id='theme-ddl' name='alkanecode_options[alkanecode_theme]'>";
		echo "<option value=''></option>";
		foreach($global_themes as $theme) {	
			$selected = ($options==$theme[1]) ? 'selected="selected"' : '';
			echo "<option value='".$theme[1]."' $selected>".$theme[0]."</option>";
		}
		echo "</select>";
		
	}

	//render language section in admin page
	function alkanecode_setting_language(){
		
		$options = get_option('alkanecode_options')["alkanecode_language"];
			  
		$global_languages = $this->global_languages;
		
		$langtotal = count($global_languages);
		$coldisplay = 3;
		$langpercol = ceil($langtotal / $coldisplay);
		$langcount = 0;
		
		echo '<div class="alkanecode-row">Select the language(s) that you wish to display in the Alkane Code plugin.  If no languages are configured the plugin will default to all languages.</div><br />';
		echo '<div class="alkanecode-row"><input type="checkbox" id="selectAllLanguages" /> Select All Toggle</div><br />';
		echo '<div class="alkanecode-row">';
		
		foreach ( $global_languages as $language) {
					
			if (($langcount == 0) || (($langcount % $langpercol) == 0))
			{
				echo '<div class="alkanecode-column">';
			}
			
			if ( (!empty($options)) && in_array( $language[0], $options ) ) {
				echo '<input type="checkbox" name="alkanecode_options[alkanecode_language]['.$language[1].']" value="'.$language[0].'" checked="checked">'.$language[0].'<br>';
			} else {
				echo '<input type="checkbox" name="alkanecode_options[alkanecode_language]['.$language[1].']" value="'.$language[0].'">'.$language[0].'<br>';
			}
			
			if (($langcount == $langtotal) || (($langcount % $langpercol) == ($langpercol - 1)))
			{
				echo '</div>';
			}			
			$langcount ++;			
		}			
		echo '</div>';
	}


	
	//add a link in Settings menu to configure plugin
	function alkanecode_admin_menu() {
		add_options_page('Alkane Code Plugin Page', 'Alkane Code', 'manage_options', 'alkanecode_settings_page', array($this,'alkanecode_adminpage'));
	}
	
	//render the plugin admin page
	function alkanecode_adminpage() {
    ?>
    <div class="wrap">
        <h2>Alkane Code</h2>
        <form action="options.php" method="post">
            <?php settings_fields('alkanecode_optiongroupname'); ?>
            <?php do_settings_sections('alkanecode_settings_page'); ?>
            <?php submit_button(); ?>
        </form>
    </div>
    <?php
	}

	/*****end admin pages***/
	
}

$ac = new alkanecode;

?>